---
apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  annotations:
    controller-gen.kubebuilder.io/version: v0.11.3
  creationTimestamp: null
  name: meshaccesslogs.kuma.io
spec:
  group: kuma.io
  names:
    categories:
    - kuma
    kind: MeshAccessLog
    listKind: MeshAccessLogList
    plural: meshaccesslogs
    singular: meshaccesslog
  scope: Namespaced
  versions:
  - name: v1alpha1
    schema:
      openAPIV3Schema:
        properties:
          apiVersion:
            description: 'APIVersion defines the versioned schema of this representation
              of an object. Servers should convert recognized schemas to the latest
              internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources'
            type: string
          kind:
            description: 'Kind is a string value representing the REST resource this
              object represents. Servers may infer this from the endpoint the client
              submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds'
            type: string
          metadata:
            type: object
          spec:
            description: Spec is the specification of the Kuma MeshAccessLog resource.
            properties:
              from:
                description: From list makes a match between clients and corresponding
                  configurations
                items:
                  properties:
                    default:
                      description: Default is a configuration specific to the group
                        of clients referenced in 'targetRef'
                      properties:
                        backends:
                          items:
                            properties:
                              file:
                                description: FileBackend defines configuration for
                                  file based access logs
                                properties:
                                  format:
                                    description: Format of access logs. Placeholders
                                      available on https://www.envoyproxy.io/docs/envoy/latest/configuration/observability/access_log/usage#command-operators
                                    properties:
                                      json:
                                        items:
                                          properties:
                                            key:
                                              type: string
                                            value:
                                              type: string
                                          type: object
                                        type: array
                                      omitEmptyValues:
                                        type: boolean
                                      plain:
                                        type: string
                                    type: object
                                  path:
                                    description: Path to a file that logs will be
                                      written to
                                    type: string
                                required:
                                - path
                                type: object
                              openTelemetry:
                                description: Defines an OpenTelemetry logging backend.
                                properties:
                                  attributes:
                                    description: Attributes can contain placeholders
                                      available on https://www.envoyproxy.io/docs/envoy/latest/configuration/observability/access_log/usage#command-operators
                                    items:
                                      properties:
                                        key:
                                          type: string
                                        value:
                                          type: string
                                      type: object
                                    type: array
                                  endpoint:
                                    description: Endpoint of OpenTelemetry collector.
                                      An empty port defaults to 4317.
                                    example: otel-collector:4317
                                    minLength: 1
                                    type: string
                                required:
                                - endpoint
                                type: object
                              tcp:
                                description: TCPBackend defines a TCP logging backend.
                                properties:
                                  address:
                                    description: Address of the TCP logging backend
                                    type: string
                                  format:
                                    description: Format of access logs. Placeholders
                                      available on https://www.envoyproxy.io/docs/envoy/latest/configuration/observability/access_log/usage#command-operators
                                    properties:
                                      json:
                                        items:
                                          properties:
                                            key:
                                              type: string
                                            value:
                                              type: string
                                          type: object
                                        type: array
                                      omitEmptyValues:
                                        type: boolean
                                      plain:
                                        type: string
                                    type: object
                                required:
                                - address
                                type: object
                            type: object
                          type: array
                      type: object
                    targetRef:
                      description: TargetRef is a reference to the resource that represents
                        a group of clients.
                      properties:
                        kind:
                          description: Kind of the referenced resource
                          enum:
                          - Mesh
                          - MeshSubset
                          - MeshService
                          - MeshServiceSubset
                          - MeshGatewayRoute
                          type: string
                        mesh:
                          description: Mesh is reserved for future use to identify
                            cross mesh resources.
                          type: string
                        name:
                          description: 'Name of the referenced resource. Can only
                            be used with kinds: `MeshService`, `MeshServiceSubset`
                            and `MeshGatewayRoute`'
                          type: string
                        tags:
                          additionalProperties:
                            type: string
                          description: Tags used to select a subset of proxies by
                            tags. Can only be used with kinds `MeshSubset` and `MeshServiceSubset`
                          type: object
                      type: object
                  required:
                  - targetRef
                  type: object
                type: array
              targetRef:
                description: TargetRef is a reference to the resource the policy takes
                  an effect on. The resource could be either a real store object or
                  virtual resource defined inplace.
                properties:
                  kind:
                    description: Kind of the referenced resource
                    enum:
                    - Mesh
                    - MeshSubset
                    - MeshService
                    - MeshServiceSubset
                    - MeshGatewayRoute
                    type: string
                  mesh:
                    description: Mesh is reserved for future use to identify cross
                      mesh resources.
                    type: string
                  name:
                    description: 'Name of the referenced resource. Can only be used
                      with kinds: `MeshService`, `MeshServiceSubset` and `MeshGatewayRoute`'
                    type: string
                  tags:
                    additionalProperties:
                      type: string
                    description: Tags used to select a subset of proxies by tags.
                      Can only be used with kinds `MeshSubset` and `MeshServiceSubset`
                    type: object
                type: object
              to:
                description: To list makes a match between the consumed services and
                  corresponding configurations
                items:
                  properties:
                    default:
                      description: Default is a configuration specific to the group
                        of destinations referenced in 'targetRef'
                      properties:
                        backends:
                          items:
                            properties:
                              file:
                                description: FileBackend defines configuration for
                                  file based access logs
                                properties:
                                  format:
                                    description: Format of access logs. Placeholders
                                      available on https://www.envoyproxy.io/docs/envoy/latest/configuration/observability/access_log/usage#command-operators
                                    properties:
                                      json:
                                        items:
                                          properties:
                                            key:
                                              type: string
                                            value:
                                              type: string
                                          type: object
                                        type: array
                                      omitEmptyValues:
                                        type: boolean
                                      plain:
                                        type: string
                                    type: object
                                  path:
                                    description: Path to a file that logs will be
                                      written to
                                    type: string
                                required:
                                - path
                                type: object
                              openTelemetry:
                                description: Defines an OpenTelemetry logging backend.
                                properties:
                                  attributes:
                                    description: Attributes can contain placeholders
                                      available on https://www.envoyproxy.io/docs/envoy/latest/configuration/observability/access_log/usage#command-operators
                                    items:
                                      properties:
                                        key:
                                          type: string
                                        value:
                                          type: string
                                      type: object
                                    type: array
                                  endpoint:
                                    description: Endpoint of OpenTelemetry collector.
                                      An empty port defaults to 4317.
                                    example: otel-collector:4317
                                    minLength: 1
                                    type: string
                                required:
                                - endpoint
                                type: object
                              tcp:
                                description: TCPBackend defines a TCP logging backend.
                                properties:
                                  address:
                                    description: Address of the TCP logging backend
                                    type: string
                                  format:
                                    description: Format of access logs. Placeholders
                                      available on https://www.envoyproxy.io/docs/envoy/latest/configuration/observability/access_log/usage#command-operators
                                    properties:
                                      json:
                                        items:
                                          properties:
                                            key:
                                              type: string
                                            value:
                                              type: string
                                          type: object
                                        type: array
                                      omitEmptyValues:
                                        type: boolean
                                      plain:
                                        type: string
                                    type: object
                                required:
                                - address
                                type: object
                            type: object
                          type: array
                      type: object
                    targetRef:
                      description: TargetRef is a reference to the resource that represents
                        a group of destinations.
                      properties:
                        kind:
                          description: Kind of the referenced resource
                          enum:
                          - Mesh
                          - MeshSubset
                          - MeshService
                          - MeshServiceSubset
                          - MeshGatewayRoute
                          type: string
                        mesh:
                          description: Mesh is reserved for future use to identify
                            cross mesh resources.
                          type: string
                        name:
                          description: 'Name of the referenced resource. Can only
                            be used with kinds: `MeshService`, `MeshServiceSubset`
                            and `MeshGatewayRoute`'
                          type: string
                        tags:
                          additionalProperties:
                            type: string
                          description: Tags used to select a subset of proxies by
                            tags. Can only be used with kinds `MeshSubset` and `MeshServiceSubset`
                          type: object
                      type: object
                  required:
                  - targetRef
                  type: object
                type: array
            required:
            - targetRef
            type: object
        type: object
    served: true
    storage: true
